Scriptname AUAFollowerAliasScript extends ReferenceAlias

AUAQuestScript property AUA auto
Keyword property VendorItemArrow auto

Event OnObjectUnequipped(Form akBaseObject, ObjectReference akReference)
	if (akBaseObject as weapon)
		; Skip external function calls if no ammo equipped
		if !GetActorReference().WornHasKeyword(VendorItemArrow)
			return
		endif
		; Retrieve equipped ammo if known
		Ammo EquippedAmmo = AUA.GetEquippedAmmo(GetActorReference())
		if !EquippedAmmo
			return
		endif
		; Retrieve equipped ammo type: 0 - other, 1 - arrows, 2 - bolts
		Int AmmoType = AUA.GetAmmoType(EquippedAmmo)
		; Retrieve equipped weapon type: 7 - bow, 12 - crossbow
		Int WeaponType = GetActorReference().GetEquippedItemType(1)
		; Unequip ammo if no bow/crossbow equipped or ammo type does not match weapon type
		if (WeaponType == 7 && AmmoType != 1) || (WeaponType == 12 && AmmoType != 2) || (WeaponType != 7 && WeaponType != 12)
			GetActorReference().UnequipItem(EquippedAmmo, false, true)
		endif
	endif
EndEvent
